︠f51dec38-655d-465b-a2f7-33a73d7f94de︠
def msk(x): #метод середини квадрату
    return int(x^2/100.0)%10000 #нове псевдовипадкове число в діапазоні [0;10000)

def lkm(x,a,c,m): #лінійний конгруентний метод
    return (a*x+c)%m #нове псевдовипадкове число в діапазоні [0;m)

def mpk(mu,sigma): #метод полярних координат (нормальний розподіл)
    s=1
    while s>=1:
        u1=random() #дві рівномірно розподілені випадкові величини на проміжку [0;1)
        u2=random()
        v1=2*u1-1   #дві рівномірно розподілені випадкові величини на проміжку [-1;1)
        v2=2*u2-1
        s=v1^2+v2^2
    x1=v1*sqrt(-2*log(s)/s)
    x2=v2*sqrt(-2*log(s)/s)
    y1=mu+sigma*x1
    y2=mu+sigma*x2
    return y1

def ml(mu): #метод логарифму (показниковий розподіл)
    u=random()
    return -mu*log(u)

@interact
def _(x=input_box(default=8192, label="початкове значення x="),\
a=input_box(default=19, label="a="),\
c=input_box(default=11, label="c="),\
m=input_box(default=31457, label="m="),\
mu=input_box(default=2, label="mu="),\
sigma=input_box(default=1, label="sigma="),\
        n=slider(vmin=1, vmax=100000,step_size=100,default=10000,label="кількість випробувань"),     \
        kol=slider(vmin=1, vmax=100,step_size=1,default=20,label="кількість проміжків"),\
        b = selector(["середини квадрату","лінійний конгруентний","убудований", \
        "полярних координат","логарифму"], \
        label="Метод", buttons=True)                 
        ):
    arr0=[] #список для накопичення згенерованих значень
    html("Метод: "+b)
    for i in range(0,n):
        if b=="середини квадрату":
            y=x/10000.0  #псевдовипадкове число в діапазоні [0;1)
            x=msk(x)
        elif b=="лінійний конгруентний":
            y=x/m  #псевдовипадкове число в діапазоні [0;1)
            x=lkm(x,a,c,m) #нове псевдовипадкове число в діапазоні [0;m-1]
        elif b=="убудований":
            y=random()  #псевдовипадкове число в діапазоні [0;1)
        elif b=="полярних координат":
            y=mpk(mu,sigma)
        elif b=="логарифму":
            y=ml(mu)
        arr0.append(y) #додавання до списку згенерованого значення
                
    series=finance.TimeSeries(arr0)
    series.plot_histogram(kol).show()
    print "Стандартне відхилення =",series.standard_deviation()
    print "Автокореляція =",series.autocorrelation()
    for i in range(1,5):
        print "Центральний момент #",i," =",series.central_moment(i)
    print "Показник Херста =",series.hurst_exponent()
    print "Максимальне значення =",series.max()
    print "Мінімальне значення =",series.min()
    print "Математичне сподівання =",series.mean()
    for i in range(1,5):
        print "Момент #",i," =",series.moment(i)
    print "R/S =",series.range_statistic()
    print "Варіація =",series.variance()
    html("Графік псевдовипадкових чисел")
    series.plot().show()
︡1a8ea4ee-0010-49f1-8ab5-ee06df15c075︡{"html": "<!--notruncate--><div padding=6 id=\"div-interact-0\"> <table width=800px height=20px bgcolor=\"#c5c5c5\"\n                 cellpadding=15><tr><td bgcolor=\"#f9f9f9\" valign=top align=left><table><tr><td align=right><font color=\"black\">\u043f\u043e\u0447\u0430\u0442\u043a\u043e\u0432\u0435 \u0437\u043d\u0430\u0447\u0435\u043d\u043d\u044f x=&nbsp;</font></td><td><input type=\"text\" value=\"8192\" size=80 onchange=\"interact(0, '_interact_.update(\\'0\\', \\'x\\', 1, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">a=&nbsp;</font></td><td><input type=\"text\" value=\"19\" size=80 onchange=\"interact(0, '_interact_.update(\\'0\\', \\'a\\', 2, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">c=&nbsp;</font></td><td><input type=\"text\" value=\"11\" size=80 onchange=\"interact(0, '_interact_.update(\\'0\\', \\'c\\', 3, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">m=&nbsp;</font></td><td><input type=\"text\" value=\"31457\" size=80 onchange=\"interact(0, '_interact_.update(\\'0\\', \\'m\\', 4, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">mu=&nbsp;</font></td><td><input type=\"text\" value=\"2\" size=80 onchange=\"interact(0, '_interact_.update(\\'0\\', \\'mu\\', 5, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">sigma=&nbsp;</font></td><td><input type=\"text\" value=\"1\" size=80 onchange=\"interact(0, '_interact_.update(\\'0\\', \\'sigma\\', 6, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\"></input></td></tr>\n<tr><td align=right><font color=\"black\">\u043a\u0456\u043b\u044c\u043a\u0456\u0441\u0442\u044c \u0432\u0438\u043f\u0440\u043e\u0431\u0443\u0432\u0430\u043d\u044c&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-n-0\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-n-0-lbl\"></font></td></tr></table><script>(function(){ var values = [\"1\",\"201\",\"401\",\"601\",\"801\",\"1001\",\"1201\",\"1401\",\"1601\",\"1801\",\"2001\",\"2201\",\"2401\",\"2601\",\"2801\",\"3001\",\"3201\",\"3401\",\"3601\",\"3801\",\"4001\",\"4201\",\"4401\",\"4601\",\"4801\",\"5001\",\"5201\",\"5401\",\"5601\",\"5801\",\"6001\",\"6201\",\"6401\",\"6601\",\"6801\",\"7001\",\"7201\",\"7401\",\"7601\",\"7801\",\"8001\",\"8201\",\"8401\",\"8601\",\"8801\",\"9001\",\"9201\",\"9401\",\"9601\",\"9801\",\"10001\",\"10201\",\"10401\",\"10601\",\"10801\",\"11001\",\"11201\",\"11401\",\"11601\",\"11801\",\"12001\",\"12201\",\"12401\",\"12601\",\"12801\",\"13001\",\"13201\",\"13401\",\"13601\",\"13801\",\"14001\",\"14201\",\"14401\",\"14601\",\"14801\",\"15001\",\"15201\",\"15401\",\"15601\",\"15801\",\"16001\",\"16201\",\"16401\",\"16601\",\"16801\",\"17001\",\"17201\",\"17401\",\"17601\",\"17801\",\"18001\",\"18201\",\"18401\",\"18601\",\"18801\",\"19001\",\"19201\",\"19401\",\"19601\",\"19801\",\"20001\",\"20201\",\"20401\",\"20601\",\"20801\",\"21001\",\"21201\",\"21401\",\"21601\",\"21801\",\"22001\",\"22201\",\"22401\",\"22601\",\"22801\",\"23001\",\"23201\",\"23401\",\"23601\",\"23801\",\"24001\",\"24201\",\"24401\",\"24601\",\"24801\",\"25001\",\"25201\",\"25401\",\"25601\",\"25801\",\"26001\",\"26201\",\"26401\",\"26601\",\"26801\",\"27001\",\"27201\",\"27401\",\"27601\",\"27801\",\"28001\",\"28201\",\"28401\",\"28601\",\"28801\",\"29001\",\"29201\",\"29401\",\"29601\",\"29801\",\"30001\",\"30201\",\"30401\",\"30601\",\"30801\",\"31001\",\"31201\",\"31401\",\"31601\",\"31801\",\"32001\",\"32201\",\"32401\",\"32601\",\"32801\",\"33001\",\"33201\",\"33401\",\"33601\",\"33801\",\"34001\",\"34201\",\"34401\",\"34601\",\"34801\",\"35001\",\"35201\",\"35401\",\"35601\",\"35801\",\"36001\",\"36201\",\"36401\",\"36601\",\"36801\",\"37001\",\"37201\",\"37401\",\"37601\",\"37801\",\"38001\",\"38201\",\"38401\",\"38601\",\"38801\",\"39001\",\"39201\",\"39401\",\"39601\",\"39801\",\"40001\",\"40201\",\"40401\",\"40601\",\"40801\",\"41001\",\"41201\",\"41401\",\"41601\",\"41801\",\"42001\",\"42201\",\"42401\",\"42601\",\"42801\",\"43001\",\"43201\",\"43401\",\"43601\",\"43801\",\"44001\",\"44201\",\"44401\",\"44601\",\"44801\",\"45001\",\"45201\",\"45401\",\"45601\",\"45801\",\"46001\",\"46201\",\"46401\",\"46601\",\"46801\",\"47001\",\"47201\",\"47401\",\"47601\",\"47801\",\"48001\",\"48201\",\"48401\",\"48601\",\"48801\",\"49001\",\"49201\",\"49401\",\"49601\",\"49801\",\"50101\",\"50301\",\"50501\",\"50701\",\"50901\",\"51101\",\"51301\",\"51501\",\"51701\",\"51901\",\"52101\",\"52301\",\"52501\",\"52701\",\"52901\",\"53101\",\"53301\",\"53501\",\"53701\",\"53901\",\"54101\",\"54301\",\"54501\",\"54701\",\"54901\",\"55101\",\"55301\",\"55501\",\"55701\",\"55901\",\"56101\",\"56301\",\"56501\",\"56701\",\"56901\",\"57101\",\"57301\",\"57501\",\"57701\",\"57901\",\"58101\",\"58301\",\"58501\",\"58701\",\"58901\",\"59101\",\"59301\",\"59501\",\"59701\",\"59901\",\"60101\",\"60301\",\"60501\",\"60701\",\"60901\",\"61101\",\"61301\",\"61501\",\"61701\",\"61901\",\"62101\",\"62301\",\"62501\",\"62701\",\"62901\",\"63101\",\"63301\",\"63501\",\"63701\",\"63901\",\"64101\",\"64301\",\"64501\",\"64701\",\"64901\",\"65101\",\"65301\",\"65501\",\"65701\",\"65901\",\"66101\",\"66301\",\"66501\",\"66701\",\"66901\",\"67101\",\"67301\",\"67501\",\"67701\",\"67901\",\"68101\",\"68301\",\"68501\",\"68701\",\"68901\",\"69101\",\"69301\",\"69501\",\"69701\",\"69901\",\"70101\",\"70301\",\"70501\",\"70701\",\"70901\",\"71101\",\"71301\",\"71501\",\"71701\",\"71901\",\"72101\",\"72301\",\"72501\",\"72701\",\"72901\",\"73101\",\"73301\",\"73501\",\"73701\",\"73901\",\"74101\",\"74301\",\"74501\",\"74701\",\"74901\",\"75101\",\"75301\",\"75501\",\"75701\",\"75901\",\"76101\",\"76301\",\"76501\",\"76701\",\"76901\",\"77101\",\"77301\",\"77501\",\"77701\",\"77901\",\"78101\",\"78301\",\"78501\",\"78701\",\"78901\",\"79101\",\"79301\",\"79501\",\"79701\",\"79901\",\"80101\",\"80301\",\"80501\",\"80701\",\"80901\",\"81101\",\"81301\",\"81501\",\"81701\",\"81901\",\"82101\",\"82301\",\"82501\",\"82701\",\"82901\",\"83101\",\"83301\",\"83501\",\"83701\",\"83901\",\"84101\",\"84301\",\"84501\",\"84701\",\"84901\",\"85101\",\"85301\",\"85501\",\"85701\",\"85901\",\"86101\",\"86301\",\"86501\",\"86701\",\"86901\",\"87101\",\"87301\",\"87501\",\"87701\",\"87901\",\"88101\",\"88301\",\"88501\",\"88701\",\"88901\",\"89101\",\"89301\",\"89501\",\"89701\",\"89901\",\"90101\",\"90301\",\"90501\",\"90701\",\"90901\",\"91101\",\"91301\",\"91501\",\"91701\",\"91901\",\"92101\",\"92301\",\"92501\",\"92701\",\"92901\",\"93101\",\"93301\",\"93501\",\"93701\",\"93901\",\"94101\",\"94301\",\"94501\",\"94701\",\"94901\",\"95101\",\"95301\",\"95501\",\"95701\",\"95901\",\"96101\",\"96301\",\"96501\",\"96701\",\"96901\",\"97101\",\"97301\",\"97501\",\"97701\",\"97901\",\"98101\",\"98301\",\"98501\",\"98701\",\"98901\",\"99101\",\"99301\",\"99501\",\"99701\",\"99901\"]; setTimeout(function() {\n    $('#slider-n-0').slider({\n        step: 1, min: 0, max: 499, value: 50,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-n-0-lbl').text(values[position]); interact(0, '_interact_.update(\\'0\\', \\'n\\', 7, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'0\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-n-0-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-n-0-lbl').text(values[$('#slider-n-0').slider('value')]);\n    }, 1); })();</script></td></tr>\n<tr><td align=right><font color=\"black\">\u043a\u0456\u043b\u044c\u043a\u0456\u0441\u0442\u044c \u043f\u0440\u043e\u043c\u0456\u0436\u043a\u0456\u0432&nbsp;</font></td><td><table><tr><td>\n        <div id=\"slider-kol-0\" style=\"margin:0px; margin-left: 1.0em; margin-right: 1.0em; width: 15.0em;\"></div>\n        </td><td><font color=\"black\" id=\"slider-kol-0-lbl\"></font></td></tr></table><script>(function(){ var values = [\"1\",\"2\",\"3\",\"4\",\"5\",\"6\",\"7\",\"8\",\"9\",\"10\",\"11\",\"12\",\"13\",\"14\",\"15\",\"16\",\"17\",\"18\",\"19\",\"20\",\"21\",\"22\",\"23\",\"24\",\"25\",\"26\",\"27\",\"28\",\"29\",\"30\",\"31\",\"32\",\"33\",\"34\",\"35\",\"36\",\"37\",\"38\",\"39\",\"40\",\"41\",\"42\",\"43\",\"44\",\"45\",\"46\",\"47\",\"48\",\"49\",\"50\",\"51\",\"52\",\"53\",\"54\",\"55\",\"56\",\"57\",\"58\",\"59\",\"60\",\"61\",\"62\",\"63\",\"64\",\"65\",\"66\",\"67\",\"68\",\"69\",\"70\",\"71\",\"72\",\"73\",\"74\",\"75\",\"76\",\"77\",\"78\",\"79\",\"80\",\"81\",\"82\",\"83\",\"84\",\"85\",\"86\",\"87\",\"88\",\"89\",\"90\",\"91\",\"92\",\"93\",\"94\",\"95\",\"96\",\"97\",\"98\",\"99\",\"100\"]; setTimeout(function() {\n    $('#slider-kol-0').slider({\n        step: 1, min: 0, max: 99, value: 19,\n        change: function (e,ui) { var position = ui.value; if(values!=null) $('#slider-kol-0-lbl').text(values[position]); interact(0, '_interact_.update(\\'0\\', \\'kol\\', 8, _interact_.standard_b64decode(\\''+encode64(position)+'\\'), globals()); _interact_.recompute(\\'0\\');'); },\n        slide: function(e,ui) { if(values!=null) $('#slider-kol-0-lbl').text(values[ui.value]); }\n    });\n    if(values != null) $('#slider-kol-0-lbl').text(values[$('#slider-kol-0').slider('value')]);\n    }, 1); })();</script></td></tr>\n<tr><td align=right><font color=\"black\">\u041c\u0435\u0442\u043e\u0434&nbsp;</font></td><td><table style=\"border:1px solid #dfdfdf; background-color:#efefef;\">\n<tr><td><button style=\"border-style:inset;\" value=\"0\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(0, '_interact_.update(\\'0\\', \\'b\\', 9, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\">\u0441\u0435\u0440\u0435\u0434\u0438\u043d\u0438 \u043a\u0432\u0430\u0434\u0440\u0430\u0442\u0443</button>\n<button style=\"border-style:outset;\" value=\"1\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(0, '_interact_.update(\\'0\\', \\'b\\', 9, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\">\u043b\u0456\u043d\u0456\u0439\u043d\u0438\u0439 \u043a\u043e\u043d\u0433\u0440\u0443\u0435\u043d\u0442\u043d\u0438\u0439</button>\n<button style=\"border-style:outset;\" value=\"2\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(0, '_interact_.update(\\'0\\', \\'b\\', 9, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\">\u0443\u0431\u0443\u0434\u043e\u0432\u0430\u043d\u0438\u0439</button>\n<button style=\"border-style:outset;\" value=\"3\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(0, '_interact_.update(\\'0\\', \\'b\\', 9, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\">\u043f\u043e\u043b\u044f\u0440\u043d\u0438\u0445 \u043a\u043e\u043e\u0440\u0434\u0438\u043d\u0430\u0442</button>\n<button style=\"border-style:outset;\" value=\"4\" onclick=\"$('BUTTON', this.parentNode).css('border-style', 'outset'); $(this).css('border-style', 'inset'); interact(0, '_interact_.update(\\'0\\', \\'b\\', 9, _interact_.standard_b64decode(\\''+encode64(this.value)+'\\'), globals()); _interact_.recompute(\\'0\\');')\">\u043b\u043e\u0433\u0430\u0440\u0438\u0444\u043c\u0443</button>\n</td></tr></table></td></tr>\n</table><div id=\"cell-interact-0\"><?__SAGE__START>\n        <table border=0 bgcolor=\"white\" width=100% height=100%>\n        <tr><td bgcolor=\"white\" align=left valign=top><pre><?__SAGE__TEXT></pre></td></tr>\n        <tr><td  align=left valign=top><?__SAGE__HTML></td></tr>\n        </table><?__SAGE__END></div></td>\n                 </tr></table></div>\n                 "}︡
